/************************************************************************
 *
 *			ob|rdqud
 *
 *				: f[^x[X
 *		t@C	: db.c
 *		쐬		: s.aizawa
 *
 ************************************************************************/

#include "pcsos.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <time.h>
#include <io.h>

#include "pcsdef.h"
#include "pcsdb.h"
#include "pcsdbsub.h"
#include "pcscom.h"

#ifdef	OS_WINDOWS
#define	DBFRead(p1,p2,p3)	(p1->fh=dbp->fh,DBFRead(p1,p2,p3))
#define	DBFRead2(p1,p2,p3)	(p1->fh=dbp->fh,DBFRead2(p1,p2,p3))
#define	DBFWrite(p1,p2,p3)	(p1->fh=dbp->fh,DBFWrite(p1,p2,p3))
#define	DBFWrite2(p1,p2,p3)	(p1->fh=dbp->fh,DBFWrite2(p1,p2,p3))
#define	DBFFlush(p1,p2)		(p1->fh=dbp->fh,DBFFlush(p1,p2))
#define	DBFDelete(p1,p2)	(p1->fh=dbp->fh,DBFDelete(p1,p2))
#define	DBFRecall(p1,p2)	(p1->fh=dbp->fh,DBFRecall(p1,p2))
#define	DBFPack(p1)		(p1->fh=dbp->fh,DBFPack(p1))
#define	DBFCheckDeleted(p1,p2,p3) (p1->fh=dbp->fh,DBFCheckDeleted(p1,p2,p3))
#define	DBFCopy(p1,p2)	(p1->fh=dbp1->fh,p2->fh=dbp2->fh,DBFCopy(p1,p2))
#define	DBFZip(p1)		(p1->fh=dbp->fh,DBFZip(p1))

#define	IDXClose(p1)		(p1->ifp->fh=p1->fh,IDXClose(p1))
#define	IDXFlush(p1,p2)		(p1->ifp->fh=p1->fh,IDXFlush(p1,p2))
#define	IDXSearch(p1,p2,p3,p4)	(p1->ifp->fh=p1->fh,IDXSearch(p1,p2,p3,p4))
#define	IDXSearch2(p1,p2,p3,p4)	(p1->ifp->fh=p1->fh,IDXSearch2(p1,p2,p3,p4))
#define	IDXSearch3(p1,p2,p3,p4,p5) (p1->ifp->fh=p1->fh,IDXSearch3(p1,p2,p3,p4,p5))
#define	IDXCompare(p1,p2,p3)	(p1->ifp->fh=p1->fh,IDXCompare(p1,p2,p3))
#define	IDXStore(p1,p2,p3)	(p1->ifp->fh=p1->fh,IDXStore(p1,p2,p3))
#define	IDXDelete(p1,p2)	(p1->ifp->fh=p1->fh,IDXDelete(p1,p2))
#define	IDXNext(p1,p2)		(p1->ifp->fh=p1->fh,IDXNext(p1,p2))
#define	IDXBack(p1,p2)		(p1->ifp->fh=p1->fh,IDXBack(p1,p2))
#define	IDXTop(p1,p2)		(p1->ifp->fh=p1->fh,IDXTop(p1,p2))
#define	IDXBottom(p1,p2)	(p1->ifp->fh=p1->fh,IDXBottom(p1,p2))
#define	IDXCount(p1,p2,p3,p4)	(p1->ifp->fh=p1->fh,IDXCount(p1,p2,p3,p4))
#define	IDXMake(p1,p2) (p1->fh=dbp->fh,p2->ifp->fh=p2->fh,IDXMake(p1,p2))
#endif

/*	[J֐`	*/
static	SHORT	_DBOpen(CHAR *, PDB *, SHORT);
static	SHORT	_DBCreate(CHAR *, PDBF_I, SHORT, PDB *, SHORT);
static	SHORT	_DBClose(PDB);
static	SHORT	_DBFlush(PDB);
static	SHORT	_DBIndex(PDB, CHAR *, SHORT *);
static	SHORT	_DBIdxCreate(PDB, CHAR *, CHAR *, SHORT, SHORT *);
static	SHORT	_DBChgIdx(PDB, SHORT);
static	SHORT	_DBSearch(PDB, CHAR *, SHORT);
static	SHORT	_DBSearch2(PDB, CHAR *, SHORT, SHORT *);
static	SHORT	_DBSearchLock(PDB, CHAR *, SHORT, LONG *);
static	SHORT	_DBCount(PDB, CHAR *, SHORT, LONG *);
static	SHORT	_DBStore(PDB, CHAR *);
static	SHORT	_DBStoreUniq(PDB, CHAR *);
static	SHORT	_DBUpdate(PDB, CHAR *);
static	SHORT	_DBUpdateKey(PDB, CHAR *, SHORT, CHAR *);
static	SHORT	_DBDelete(PDB);
static	SHORT	_DBRecall(PDB);
static	SHORT	_DBDelete2(PDB);
static	SHORT	_DBDelete3(PDB);
static	SHORT	_DBDeleteKey(PDB, CHAR *, SHORT, SHORT);
static	SHORT	_DBTop(PDB);
static	SHORT	_DBBottom(PDB);
static	SHORT	_DBSet(PDB, LONG);
static	SHORT	_DBSkip(PDB, LONG);
static	SHORT	_DBReindex(PDB);
static	SHORT	_DBPack(PDB);
static	SHORT	_DBRead(PDB, CHAR *);
static	SHORT	_DBReadNext(PDB, SHORT, CHAR *, SHORT *);
static	SHORT	_DBReadBack(PDB, SHORT, CHAR *, SHORT *);
static	SHORT	_DBReadKey(PDB, CHAR *, SHORT, CHAR *, SHORT, SHORT *);
static	SHORT	_DBReadBinary(PDB, CHAR *, HPSTR, LONG, LONG *);
static	SHORT	_DBWriteBinary(PDB, CHAR *, HPSTR, LONG);
static	SHORT	_DBGetBinarySize(PDB, CHAR *, LONG *);
static	SHORT	_DBClrRecord(PDB);
static	SHORT	_DBGetRecord(PDB);
static	SHORT	_DBGetField(PDB, CHAR *, VOID *, SHORT *, SHORT *);
static	SHORT	_DBSetField(PDB, CHAR *, VOID *);
static	SHORT	_DBAddRecord(PDB);
static	SHORT	_DBUpdRecord(PDB);
static	SHORT	_DBCheckDeleted(PDB, SHORT *);
static	SHORT	_DBSetFilter(PDB, CHAR *);
static	SHORT	_DBSelect(PDB, CHAR *, LONG *);
static	SHORT	_DBSetDeleted(PDB, SHORT);
static	SHORT	_DBLRecNo(PDB, LONG *);
static	SHORT	_DBLRecCount(PDB, LONG *);
static	SHORT	_DBLSet(PDB, LONG);
static	SHORT	_DBZip(PDB);
static	SHORT	_DBCheckUpdate(PDB, SHORT *);
static	SHORT	_DBLock(PDB, SHORT);
static	SHORT	_DBUnlock(PDB, SHORT);
static	SHORT	_DBRecCount(PDB, LONG *);
static	SHORT	_DBBof(PDB, SHORT *);
static	SHORT	_DBDbf(PDB, CHAR *);
static	SHORT	_DBEof(PDB, SHORT *);
static	SHORT	_DBNField(PDB, SHORT *);
static	SHORT	_DBField(PDB, SHORT, PDBF_I);
static	SHORT	_DBNdx(PDB, SHORT, CHAR *);
static	SHORT	_DBRecNo(PDB, LONG *);
static	SHORT	_DBRecSize(PDB, SHORT *);
static	SHORT	_DBSetReadField(PDB, CHAR *, SHORT *);
static	SHORT	_DBSetScramble(PDB);
static	SHORT	_DBUpdateEx(PDB, LONG, CHAR *);
static	SHORT	_DBDeleteEx(PDB, LONG);
static	SHORT	_DBRecallEx(PDB, LONG);
static	SHORT	_DBDelete2Ex(PDB, LONG);
static	SHORT	_DBLockEx(PDB, LONG, SHORT);
static	SHORT	_FileLockCheck(PDB);
static	SHORT	_RecordLockCheck(PDB);
static	SHORT	_SkipDeleted(PDB, int);
static	SHORT	_Skip(PDB, LONG);
static	VOID	_CheckBof(PDB, LONG);
static	VOID	_CheckEof(PDB, LONG);

CRITICALSECTION	csDB;		/* DB N`JZNV */
CRITICALSECTION	csDBL;		/* DBLOCK N`JZNV */

CHAR	bitTable1[8] = {0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80};
CHAR	bitTable2[8] = {0xfe, 0xfd, 0xfb, 0xf7, 0xef, 0xdf, 0xbf, 0x7f};

/*=======================================================================
 |
 |		f[^x[XI[v
 |
 |	SHORT	DBOpen(fileName, dbpp, permission)
 |
 |		CHAR	*fileName;	f[^t@C
 |		PDB		*dbpp;		ca|C^
 |		SHORT	permission;	ANZX[h
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBOpen(CHAR *fileName, PDB *dbpp, SHORT permission)
{
	SHORT	err;
	CHAR	fileNameTmp[128];
	CHAR	password[8];
	CHAR	*p;
	int len;

	ENTER_CRITICAL_SECTION(&csDB);

	if ((p = strchr(fileName, ',')) != NULL) {
		len = p - fileName;
		memcpy(fileNameTmp, fileName, len);
		fileNameTmp[len] = '\0';
	} else
		strcpy(fileNameTmp, fileName);

	err = _DBOpen(fileNameTmp, dbpp, permission);

	if (err == 0) {
		if (p == NULL) {
			if ((*dbpp)->dp->dhp->password[0] != 0) {
				_DBClose(*dbpp);
				*dbpp = NULL;
				err = ERROR_DB_PASSWORD;
			}
		} else {
			p++;
			memset(password, ' ', sizeof(password));
			memcpy(password, p, min(strlen(p), 8));
			Scramble1(password + 1, 7, password[0]);
			if (memcmp((*dbpp)->dp->dhp->password, password, 8) != 0) {
				_DBClose(*dbpp);
				*dbpp = NULL;
				err = ERROR_DB_PASSWORD;
			}
		}
	}
	LEAVE_CRITICAL_SECTION(&csDB);

	return err;
}

static	SHORT	_DBOpen(CHAR *fileName, PDB *dbpp, SHORT permission)
{
	PDB	dbp;
	SHORT	err;

	*dbpp = NULL;

	// ANZX[h`FbN
	if (!(permission & PERMISSION_READ))
		return ERROR_FILE_PERMISSION;

	/* f[^x[XǗGAm */
	if ((dbp = malloc(sizeof(DB))) == NULL)
		return ERROR_DB_MEMORY;

	memset(dbp, 0, sizeof(DB));

	/* f[^t@CicaejI[v */
	if ((err = DBFOpen(fileName, &dbp->dp)) != 0) {
		_DBClose(dbp);
		return err;
	}

#ifdef	MULTI_OPEN
	dbp->fh = dbp->dp->fh;
#endif

	/* R[hobt@m */
	if ((dbp->rbp = malloc(dbp->dp->dhp->lRec + 1)) == NULL) {
		_DBClose(dbp);
		return ERROR_DB_MEMORY;
	}

	/* R[hobt@mۂQ */
	if ((dbp->rbp2 = malloc(dbp->dp->lRec)) == NULL) {
		_DBClose(dbp);
		return ERROR_DB_MEMORY;
	}

	dbp->readSize = dbp->dp->lRec;

	dbp->permission = permission;

	/* `FC */
	dbp->chain = dbp->dp->dbp;
	dbp->dp->dbp = dbp;

	dbp->updateCount = dbp->dp->updateCount;

	_CheckBof(dbp, 1L);	/* ane`FbN*/

	*dbpp = dbp;

	return 0;
}

/*=======================================================================
 |
 |		f[^x[X쐬
 |
 |	SHORT	DBCreate(fileName, dip, nField, dbpp, permission)
 |
 |		CHAR	*fileName;	f[^t@C
 |		PDBF_I	dip;		f[^t@C
 |		SHORT	nField;		tB[h
 |		PDB	*dbpp;		ca|C^
 |		SHORT	permission;	ANZX[h
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBCreate(CHAR *fileName, PDBF_I dip, SHORT nField, PDB *dbpp, SHORT permission)
{
	CHAR	*p;
	SHORT	err;

	ENTER_CRITICAL_SECTION(&csDB);

	if ((p = strchr(fileName, ',')) != NULL)
		*p = '\0';

	err = _DBCreate(fileName, dip, nField, dbpp, permission);

	if (p != NULL) {
		*p = ',';
		if (err == 0)
			DBSetPassword(*dbpp, p + 1);
	}

	LEAVE_CRITICAL_SECTION(&csDB);

	return err;
}

static	SHORT	_DBCreate(CHAR *fileName, PDBF_I dip, SHORT nField, PDB *dbpp, SHORT permission)
{
	PDBF	dp;
	SHORT	err;

	*dbpp = NULL;

	// ANZX[h`FbN
	if ((permission & (PERMISSION_READ | PERMISSION_WRITE)) != (PERMISSION_READ | PERMISSION_WRITE))
		return ERROR_FILE_PERMISSION;

	/* f[^t@C쐬 */
	if ((err = DBFCreate(fileName, dip, nField, &dp)) != 0)
		return err;

	/* f[^t@CN[Y */
	if ((err = DBFClose(dp)) != 0)
		return err;

	return _DBOpen(fileName, dbpp, permission);
}

/*=======================================================================
 |
 |		f[^x[XN[Y
 |
 |	SHORT	DBClose(dbp)
 |
 |		PDB	dbp;		ca|C^
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBClose(PDB dbp)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&csDB);
	err = _DBClose(dbp);
	LEAVE_CRITICAL_SECTION(&csDB);

	return err;
}

static	SHORT	_DBClose(PDB dbp)
{
	PDB	*dbpp;
	int	i;

	if (dbp->dp != NULL) {
		/* SbN */
		if (dbp->readLockCount != 0)
			dbp->readLockCount = 1;
		if (dbp->writeLockCount != 0)
			dbp->writeLockCount = 1;
		_DBUnlock(dbp, LOCK_FILE_WRITE);
		_DBUnlock(dbp, LOCK_RECORD_WRITE);
		_DBUnlock(dbp, LOCK_FILE_READ);
		_DBUnlock(dbp, LOCK_RECORD_READ);

		/* `FC؂藣 */
		for (dbpp = &dbp->dp->dbp; *dbpp != 0; dbpp = &(*dbpp)->chain){
			if ((*dbpp) == dbp) {
				*dbpp = (*dbpp)->chain;
				break;
			}
		}

		/* f[^t@CN[Y */
#ifdef	MULTI_OPEN
		if (dbp->dp->dbp == NULL) {
			dbp->dp->fh = dbp->fh;
			DBFClose(dbp->dp);
		} else
			__CLOSE(dbp->fh);
#else
		if (dbp->dp->dbp == NULL)
			DBFClose(dbp->dp);
		else
			DBFFlush(dbp->dp, FALSE);
#endif
	}

	/* CfbNXt@CN[Y */
	for (i = 1; i <= dbp->nIdx; i++) {
		if (dbp->ip[i] != NULL)
			IDXClose(dbp->ip[i]);
	}

	/* oCif[^ǂݍݏ */
	if (dbp->brp != NULL)
		free(dbp->brp);

	/* R[hobt@ */
	if (dbp->rbp != NULL)
		free(dbp->rbp);

	/* R[hobt@Q */
	if (dbp->rbp2 != NULL)
		free(dbp->rbp2);

	/* tB^ */
	if (dbp->filter != NULL)
		free(dbp->filter);

	/* I */
	if (dbp->select != NULL)
		HFREE(dbp->select);

	/* ǂݍ݃tB[h */
	if (dbp->readField != NULL)
		free(dbp->readField);

	free(dbp);	/* ǗGA */

	return 0;
}

/*=======================================================================
 |
 |		t@C|o
 |
 |	SHORT	DBFlush(dbp)
 |
 |		PDB	dbp;		ca|C^
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBFlush(PDB dbp)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBFlush(dbp);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBFlush(PDB dbp)
{
	int	i;

	/* f[^t@CtbV */
	DBFFlush(dbp->dp, TRUE);

	/* CfbNXt@CtbV */
	for (i = 1; i <= dbp->nIdx; i++) {
		if (dbp->ip[i] != NULL)
			IDXFlush(dbp->ip[i], TRUE);
	}

	return 0;
}

/*=======================================================================
 |
 |		CfbNXt@CI[v
 |
 |	SHORT	DBIndex(dbp, fileName, idxNo)
 |
 |		PDB	dbp;		ca|C^
 |		CHAR	*fileName;	CfbNXt@C
 |		SHORT	*idxNo;		CfbNXt@Cԍ
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBIndex(PDB dbp, CHAR *fileName, SHORT *idxNo)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBIndex(dbp, fileName, idxNo);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBIndex(PDB dbp, CHAR *fileName, SHORT *idxNo)
{
	PIDX	ip;
	SHORT	err;

	*idxNo = 0;

	/* CfbNXt@CI[v`FbN */
	if (dbp->nIdx >= MAX_IDX)
		return ERROR_DB_IDXOVER;

	/* CfbNXt@CI[v */
	if ((err = IDXOpen(fileName, &ip)) != 0)
		return err;

	if (dbp->dp->adjustFlag && ip->chain == NULL) {
		if ((err = IDXMake(dbp->dp, ip)) != 0) {
			IDXClose(ip);
			return err;
		}
	}

	dbp->ip[dbp->nIdx+1] = ip;
	dbp->nIdx++;		/* CfbNXt@CXV */

	/* }X^[CfbNXt@CԍZbg */
	if (dbp->master == 0) {
		dbp->master = dbp->nIdx;
		_DBTop(dbp);
	}

	*idxNo = dbp->nIdx;

	return 0;
}

/*=======================================================================
 |
 |		CfbNXt@C쐬
 |
 |	SHORT	DBIdxCreate(dbp, fileName, key, uniq, idxNo)
 |
 |		PDB	dbp;		ca|C^
 |		CHAR	*fileName;	CfbNXt@C
 |		CHAR	*key;		L[
 |		SHORT	uniq;		OFL[̏d@PFȂ
 |		SHORT	*idxNo;		CfbNXt@Cԍ
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBIdxCreate(PDB dbp, CHAR *fileName, CHAR *key, SHORT uniq,
								SHORT *idxNo)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBIdxCreate(dbp, fileName, key, uniq, idxNo);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBIdxCreate(PDB dbp, CHAR *fileName, CHAR *key, SHORT uniq,
								SHORT *idxNo)
{
	PDBF	dp;
	PIDX	ip;
	SHORT	err;

	dp = dbp->dp;
	*idxNo = 0;

	// ANZX[h`FbN
	if (!(dbp->permission & PERMISSION_WRITE))
		return ERROR_FILE_PERMISSION;

	/* CfbNXt@CI[v`FbN */
	if (dbp->nIdx >= MAX_IDX)
		return ERROR_DB_IDXOVER;

	/* CfbNXt@C쐬 */
	if ((err = IDXCreate(fileName, key, uniq, &ip)) != 0)
		return err;

	/* CfbNX\z */
	if ((err = IDXMake(dp, ip)) != 0) {
		IDXClose(ip);
		return err;
	}

	dbp->ip[dbp->nIdx+1] = ip;	/* CfbNX|C^Z[u */

	dbp->nIdx++;		/* CfbNXt@CXV */

	/* }X^[CfbNXt@CԍZbg */
	if (dbp->master == 0) {
		dbp->master = dbp->nIdx;
		_DBTop(dbp);
	}

	*idxNo = dbp->nIdx;

	return 0;
}

/*=======================================================================
 |
 |		}X^[CfbNX؂ւ
 |
 |	SHORT	DBChgIdx(dbp, n)
 |
 |		PDB	dbp;		ca|C^
 |		SHORT	n;		CfbNXt@Cԍ
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBChgIdx(PDB dbp, SHORT n)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBChgIdx(dbp, n);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBChgIdx(PDB dbp, SHORT n)
{
	if (n < 0 || n > dbp->nIdx)
		return ERROR_DB_PARAMETER;

	dbp->master = n;	/* }X^[CfbNXԍZbg */
	return _DBTop(dbp);	/* 擪R[h */
}

/*=======================================================================
 |
 |		CfbNXt@Cɂ錟iSvCOvj
 |
 |	SHORT	DBSearch(dbp, key, len)
 |
 |		PDB	dbp;		ca|C^
 |		CHAR	*key;		镶
 |		SHORT	len;		镶̒
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBSearch(PDB dbp, CHAR *key, SHORT len)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBSearch(dbp, key, len);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBSearch(PDB dbp, CHAR *key, SHORT len)
{
	PIDX	ip;
	double	dTmp;
	LONG	lTmp;
	LONG	rno;
	SHORT	err;

	/* |C^Zbg */
	ip = dbp->ip[dbp->master];

	/* CfbNXt@C΃G[ */
	if (ip == NULL)
		return ERROR_DB_NOINDEX;

	switch (ip->ifp->ihp->type) {
	case KEY_TYPE_N:
		/* ɕϊ */
		dTmp = natof(key, len);
		key = (CHAR *)&dTmp;
		len = 8;
		break;
	case KEY_TYPE_I:
		/* 𐮐ɕϊ */
		lTmp = natol(key, len);
		key = (CHAR *)&lTmp;
		len = 4;
		break;
	}

	/* CfbNX */
	if ((err = IDXSearch(ip, key, len, &rno)) != 0)
		return err;

	_CheckEof(dbp, rno);	/* dne`FbN */

	if (dbp->filter != NULL || dbp->select != NULL ||
						dbp->setDeleted != 0) {
		/* 폜R[hXLbv */
		if ((err = _SkipDeleted(dbp, 1)) != 0)
			return err;
		if (dbp->eof == 0) {
			if (IDXCompare(ip, key, len) != 0)
				_CheckEof(dbp, 0L);
		}
	}

	return 0;
}

/*=======================================================================
 |
 |		CfbNXt@Cɂ錟i͈͎wΉj
 |
 |	SHORT	DBSearch2(dbp, key, len, find)
 |
 |		PDB	dbp;		ca|C^
 |		CHAR	*key;		镶
 |		SHORT	len;		镶̒
 |		SHORT	*find;		
 |					OFYR[h
 |					PFv郌R[h
 |					QFv郌R[h͌Ȃ
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBSearch2(PDB dbp, CHAR *key, SHORT len, SHORT *find)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBSearch2(dbp, key, len, find);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBSearch2(PDB dbp, CHAR *key, SHORT len, SHORT *find)
{
	PIDX	ip;
	double	dTmp;
	LONG	lTmp;
	LONG	rno;
	SHORT	err;

	/* |C^Zbg */
	ip = dbp->ip[dbp->master];

	/* CfbNXt@CȂΉȂ */
	if (ip == NULL)
		return ERROR_DB_NOINDEX;

	switch (ip->ifp->ihp->type) {
	case KEY_TYPE_N:
		/* ɕϊ */
		dTmp = natof(key, len);
		key = (CHAR *)&dTmp;
		len = 8;
		break;
	case KEY_TYPE_I:
		/* 𐮐ɕϊ */
		lTmp = natol(key, len);
		key = (CHAR *)&lTmp;
		len = 4;
		break;
	}

	/*  */
	if ((err = IDXSearch2(ip, key, len, &rno)) != 0)
		return err;

	_CheckEof(dbp, rno);	/* dne`FbN */

	if (dbp->filter != NULL || dbp->select != NULL ||
						dbp->setDeleted != 0) {
		/* 폜R[hXLbv */
		if ((err = _SkipDeleted(dbp, 1)) != 0)
			return err;
	}

	if (dbp->eof)
		*find = 0;
	else if (IDXCompare(ip, key, len) == 0)
		*find = 1;
	else
		*find = 2;

	return 0;
}

/*=======================================================================
 |
 |		CfbNXt@Cɂ錟ibNtj
 |
 |	SHORT	DBSearchLock(dbp, key, len, count)
 |
 |		PDB	dbp;		ca|C^
 |		CHAR	*key;		镶
 |		SHORT	len;		镶̒
 |		LONG	count;		ꂽR[h
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBSearchLock(PDB dbp, CHAR *key, SHORT len, LONG *count)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBSearchLock(dbp, key, len, count);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBSearchLock(PDB dbp, CHAR *key, SHORT len, LONG *count)
{
	LONG	l;
	SHORT	err;

	/* ΏۃR[ho */
	if ((err = _DBCount(dbp, key, len, count)) != 0)
		return err;

	if (*count == 0)
		return 0;

	if ((err = _DBSearch(dbp, key, len)) != 0)
		return err;

	for (l = 0; l < *count; l++) {
		if ((err = _DBLock(dbp, LOCK_RECORD_WRITE)) != 0) {
			_DBUnlock(dbp, LOCK_RECORD_WRITE);
			return err;
		}
		if ((err = _DBSkip(dbp, 1L)) != 0) {
			_DBUnlock(dbp, LOCK_RECORD_WRITE);
			return err;
		}
	}

	if ((err = _DBSearch(dbp, key, len)) != 0) {
		_DBUnlock(dbp, LOCK_RECORD_WRITE);
		return err;
	}

	return 0;
}

/*=======================================================================
 |
 |		L[Ɉv郌R[h̎擾
 |
 |	SHORT	DBCount(dbp, key, len, nRec)
 |
 |		PDB	dbp;		ca|C^
 |		CHAR	*key;		镶
 |		SHORT	len;		镶̒
 |		LONG	*nRec;		L[ɈvR[h
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBCount(PDB dbp, CHAR *key, SHORT len, LONG *nRec)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBCount(dbp, key, len, nRec);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBCount(PDB dbp, CHAR *key, SHORT len, LONG *nRec)
{
	PIDX	ip;
	double	dTmp;
	LONG	lTmp;
	LONG	count, rno;
	SHORT	err;

	/* |C^Zbg */
	ip = dbp->ip[dbp->master];

	/* CfbNXt@CȂΉȂ */
	if (ip == NULL)
		return ERROR_DB_NOINDEX;

	switch (ip->ifp->ihp->type) {
	case KEY_TYPE_N:
		/* ɕϊ */
		dTmp = natof(key, len);
		key = (CHAR *)&dTmp;
		len = 8;
		break;
	case KEY_TYPE_I:
		/* 𐮐ɕϊ */
		lTmp = natol(key, len);
		key = (CHAR *)&lTmp;
		len = 4;
		break;
	}

	/*  */
	if ((err = IDXSearch(ip, key, len, &rno)) != 0)
		return err;

	_CheckEof(dbp, rno);	/* dne`FbN */

	/* 폜R[hXLbv */
	if ((err = _SkipDeleted(dbp, 1)) != 0)
		return err;

	count = 0;
	while (dbp->eof == 0) {
		if (IDXCompare(ip, key, len) != 0)
			break;
		count++;
		if ((err = _DBSkip(dbp, 1L)) != 0)
			return err;
	}

	*nRec = count;		/* ʃZbg */

	return 0;
}

/*=======================================================================
 |
 |		R[hǉ
 |
 |	SHORT	DBStore(dbp, rec)
 |
 |		PDB	dbp;		ca|C^
 |		CHAR	*rec;		ǉ郌R[hf[^ւ̃|C^
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBStore(PDB dbp, CHAR *rec)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBStore(dbp, rec);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBStore(PDB dbp, CHAR *rec)
{
	PDBF	dp;
	PIDX	ip;
	int	i;
	PDBF_H	dhp;
	SHORT	err;
	CHAR	kbuf[256];

	// ANZX[h`FbN
	if (!(dbp->permission & PERMISSION_WRITE))
		return ERROR_FILE_PERMISSION;

	/* |C^Zbg */
	dp = dbp->dp;
	dhp = dp->dhp;

	/* t@CbN`FbN */
	if (dp->readLockCount != 0 ||
			(dp->writeLockCount != 0 && dbp->writeLockCount == 0))
		return ERROR_DB_LOCK;

	dbp->rbp[0] = ' ';	/* 폜R[htONA */

	memcpy(dbp->rbp + 1, rec, dp->lRec);	/* f[^Rs[ */

	/* oCitB[hNA */
	if (dhp->lRec - 1 > dp->lRec)
		memset(dbp->rbp + 1 + dp->lRec, 0, dhp->lRec - 1 - dp->lRec);

	/* f[^t@Cɒǉ */
	dbp->rno = ++dhp->nRec;
	if ((err = DBFWrite(dp, dbp->rno, dbp->rbp)) != 0)
		return err;

	/* CfbNXt@CXV */
	for (i = 1; i <= dbp->nIdx; i++) {
		ip = dbp->ip[i];

		if (GetKey(dp, dbp->rbp + 1, ip->ifp->ihp, kbuf) != 0)
			IDXStore(ip, kbuf, dhp->nRec);
	}

	/* CfbNXt@C̃|C^Zbg */
	_DBSet(dbp, dbp->rno);

	return 0;
}

/*=======================================================================
 |
 |		R[hǉidj
 |
 |	SHORT	DBStoreUniq(dbp, rec)
 |
 |		PDB	dbp;		ca|C^
 |		CHAR	*rec;		ǉ郌R[hf[^ւ̃|C^
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBStoreUniq(PDB dbp, CHAR *rec)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBStoreUniq(dbp, rec);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBStoreUniq(PDB dbp, CHAR *rec)
{
	PIDX	ip;
	PIDX_H	ihp;
	int	i;
	SHORT	err;
	LONG	rno;
	CHAR	kbuf[256];

	// ANZX[h`FbN
	if (!(dbp->permission & PERMISSION_WRITE))
		return ERROR_FILE_PERMISSION;

	/* d`FbN */
	for (i = 1; i <= dbp->nIdx; i++) {
		ip = dbp->ip[i];
		ihp = ip->ifp->ihp;

		if (ihp->uniq && GetKey(dbp->dp, rec, ihp, kbuf) != 0) {
			if ((err = IDXSearch(ip, kbuf, ihp->lKey, &rno)) != 0)
				return err;
			if (rno != 0)
				return ERROR_DB_DBLKEY;
		}
	}

	return _DBStore(dbp, rec);
}

/*=======================================================================
 |
 |		R[hXV
 |
 |	SHORT	DBUpdate(dbp, rec)
 |
 |		PDB	dbp;		ca|C^
 |		CHAR	*rec;		XV郌R[hf[^ւ̃|C^
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBUpdate(PDB dbp, CHAR *rec)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBUpdate(dbp, rec);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBUpdate(PDB dbp, CHAR *rec)
{
	PDBF	dp;
	PIDX	ip;
	int	i;
	PDBF_H	dhp;
	PIDX_H	ihp;
	LONG	rno;
	SHORT	err;
	CHAR	kbuf1[256], kbuf2[256];

	// ANZX[h`FbN
	if (!(dbp->permission & PERMISSION_WRITE))
		return ERROR_FILE_PERMISSION;

	/* ane܂͂dneȂG[ */
	if (dbp->bof || dbp->eof)
		return ERROR_DB_EOF;

	/* t@CbN`FbN */
	if ((err = _RecordLockCheck(dbp)) != 0)
		return err;

	/* |C^Zbg */
	dp = dbp->dp;
	dhp = dp->dhp;

	/* R[hǂݍ */
	if ((err = DBFRead2(dp, dbp->rno, dbp->rbp)) != 0)
		return err;

	/* CfbNXt@CXV */
	for (i = 1; i <= dbp->nIdx; i++) {
		ip = dbp->ip[i];
		ihp = ip->ifp->ihp;

		if (GetKey(dp, dbp->rbp, ihp, kbuf1) != 0) {
			IDXSearch3(ip, kbuf1, ihp->lKey, dbp->rno, &rno);

			GetKey(dp, rec, ihp, kbuf2);
			if (rno != 0) {
				if (memcmp(kbuf1, kbuf2, ihp->lKey) != 0) {
					IDXDelete(ip, rno);
					IDXStore(ip, kbuf2, rno);
				}
			} else
				IDXStore(ip, kbuf2, dbp->rno);
		}
	}

	/* f[^t@CXV */
	if ((err = DBFWrite2(dp, dbp->rno, rec)) != 0)
		return err;

	/* CfbNXt@C̃|C^Zbg */
	_DBSet(dbp, dbp->rno);

	return 0;
}

/*=======================================================================
 |
 |		L[wɂ郌R[hXV
 |
 |	SHORT	DBUpdateKey(dbp, key, len, buf)
 |
 |		PDB	dbp;		ca|C^
 |		CHAR	*key;		L[
 |		SHORT	len;		L[
 |		CHAR	*buf;		R[hobt@
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBUpdateKey(PDB dbp, CHAR *key, SHORT len, CHAR *buf)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBUpdateKey(dbp, key, len, buf);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBUpdateKey(PDB dbp, CHAR *key, SHORT len, CHAR *buf)
{
	LONG	count;
	SHORT	err;

	// ANZX[h`FbN
	if (!(dbp->permission & PERMISSION_WRITE))
		return ERROR_FILE_PERMISSION;

	/* R[h */
	if ((err = _DBCount(dbp, key, len, &count)) != 0)
		return err;

	if (count == 0)
		return ERROR_DB_NOKEY;
	if (count > 1)
		return ERROR_DB_DBLKEY;

	if ((err = _DBSearch(dbp, key, len)) != 0)
		return err;

	if ((err = _DBUpdate(dbp, buf)) != 0)
		return err;

	return 0;
}

/*=======================================================================
 |
 |		R[h폜
 |
 |	SHORT	DBDelete(dbp)
 |
 |		PDB	dbp;		ca|C^
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBDelete(PDB dbp)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBDelete(dbp);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBDelete(PDB dbp)
{
	SHORT	err;

	// ANZX[h`FbN
	if (!(dbp->permission & PERMISSION_WRITE))
		return ERROR_FILE_PERMISSION;

	/* ane܂͂dneȂG[ */
	if (dbp->bof || dbp->eof)
		return ERROR_DB_EOF;

	/* t@CbN`FbN */
	if ((err = _RecordLockCheck(dbp)) != 0)
		return err;

	/* 폜}[NZbg */
	if ((err = DBFDelete(dbp->dp, dbp->rno)) != 0)
		return err;

	/* 폜R[hXLbv */
	if ((err = _SkipDeleted(dbp, 1)) != 0)
		return err;

	return 0;
}

/*=======================================================================
 |
 |		R[h
 |
 |	SHORT	DBRecall(dbp)
 |
 |		PDB	dbp;		ca|C^
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBRecall(PDB dbp)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBRecall(dbp);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBRecall(PDB dbp)
{
	SHORT	err;

	// ANZX[h`FbN
	if (!(dbp->permission & PERMISSION_WRITE))
		return ERROR_FILE_PERMISSION;

	/* ane܂͂dneȂG[ */
	if (dbp->bof || dbp->eof)
		return ERROR_DB_EOF;

	/* t@CbN`FbN */
	if ((err = _RecordLockCheck(dbp)) != 0)
		return err;

	/* 폜}[N */
	if ((err = DBFRecall(dbp->dp, dbp->rno)) != 0)
		return err;

	return 0;
}

/*=======================================================================
 |
 |		R[h̕I폜
 |
 |	SHORT	DBDelete2(dbp)
 |
 |		PDB	dbp;		ca|C^
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBDelete2(PDB dbp)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBDelete2(dbp);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBDelete2(PDB dbp)
{
	PDB	dbp2;
	PDBF	dp;
	PDBF_H	dhp;
	PIDX	ip;
	PIDX_H	ihp;
	PFIELD	flp;
	CHAR	*fdp;
	int	i;
	CHAR	*rbufp;
	LONG	rno;
	SHORT	err;
	CHAR	kbuf[256];
	CHAR	kbuf2[256];
	PDBLOCK	dlp, *dlpp, chain;

	// ANZX[h`FbN
	if (!(dbp->permission & PERMISSION_WRITE))
		return ERROR_FILE_PERMISSION;

	/* ane܂͂dneȂG[ */
	if (dbp->bof || dbp->eof)
		return ERROR_DB_EOF;

	/* t@CbN`FbN */
	if ((err = _RecordLockCheck(dbp)) != 0)
		return err;

	dp = dbp->dp;
	dhp = dp->dhp;

	/* JgR[hǂݍ */
	if ((err = DBFRead(dp, dbp->rno, dbp->rbp)) != 0)
		return err;

	/* oCif[^̍폜 */
	if (dp->bfp != NULL) {
		for (i = 0, flp = dp->flp; i < dp->nField; i++, flp++) {
			if (flp->type == 'B') {
				fdp = &dbp->rbp[flp->offset + 1];
				BINDelete(dp->bfp, *(LONG *)fdp);
			}
		}
	}

	/* [NGAm */
	if ((rbufp = malloc(dp->dhp->lRec)) == 0)
		return ERROR_DB_MEMORY;

	/* ŏIR[hǂݍ */
	if ((err = DBFRead(dp, dhp->nRec, rbufp)) != 0) {
		free(rbufp);
		return err;
	}

	/* IŏIR[hCfbNXt@C폜 */
	for (i = 1; i <= dbp->nIdx; i++) {
		ip = dbp->ip[i];
		ihp = ip->ifp->ihp;

		if (GetKey(dp, rbufp + 1, ihp, kbuf) != 0) {
			IDXSearch3(ip, kbuf, ihp->lKey, dhp->nRec, &rno);
			if (rno != 0)
				IDXDelete(ip, rno);	/* L[̍폜 */
		}
	}

	rno = dbp->rno;		/* JgR[hԍۑ */

	/* ŏIR[hȊȌꍇA폜郌R[hɍŏIR[h㏑ */
	if (rno != dhp->nRec) {
		/* CfbNXt@CXV */
		for (i = 1; i <= dbp->nIdx; i++) {
			ip = dbp->ip[i];
			ihp = ip->ifp->ihp;

			if (GetKey(dp, dbp->rbp + 1, ihp, kbuf) != 0) {
				IDXSearch3(ip, kbuf, ihp->lKey, dbp->rno,
									&rno);

				GetKey(dp, rbufp + 1, ihp, kbuf2);
				if (rno != 0) {
					if (memcmp(kbuf, kbuf2, ihp->lKey)
									!= 0) {
						IDXDelete(ip, rno);
						IDXStore(ip, kbuf2, rno);
					}
				} else
					IDXStore(ip, kbuf2, dbp->rno);
			}
		}

		/* f[^t@CXV */
		if ((err = DBFWrite(dp, dbp->rno, rbufp)) != 0)
			return err;
	}

	free(rbufp);

	ENTER_CRITICAL_SECTION(&csDB);

	/* JgR[h폜ꂽꍇ͂dneƂ */
	for (dbp2 = dp->dbp; dbp2 != NULL; dbp2 = dbp2->chain) {
		if (dbp2->rno == rno)
			_CheckEof(dbp2, 0L);
	}

	/* JgR[hԍ␳ */
	for (dbp2 = dp->dbp; dbp2 != NULL; dbp2 = dbp2->chain) {
		if (dbp2->rno == dhp->nRec)
			dbp2->rno = rno;
	}

	LEAVE_CRITICAL_SECTION(&csDB);

	ENTER_CRITICAL_SECTION(&csDBL);

	/* JgR[h̃bN */
	for (dlpp = &dp->rdlp; *dlpp != 0; ) {
		if ((*dlpp)->rno == rno) {
			chain = (*dlpp)->chain;
			free(*dlpp);
			*dlpp = chain;
		} else
			dlpp = &(*dlpp)->chain;
	}

	for (dlpp = &dp->wdlp; *dlpp != 0; dlpp = &(*dlpp)->chain) {
		if ((*dlpp)->rno == rno) {
			chain = (*dlpp)->chain;
			free(*dlpp);
			*dlpp = chain;
			break;
		} 
	}

	/* ǂݍ݃bNR[hԍ␳ */
	for (dlp = dp->rdlp; dlp != NULL; dlp = dlp->chain) {
		if (dlp->rno == dhp->nRec)
			dlp->rno = rno;
	}

	/* ݃bNR[hԍ␳ */
	for (dlp = dp->wdlp; dlp != NULL; dlp = dlp->chain) {
		if (dlp->rno == dhp->nRec)
			dlp->rno = rno;
	}

	LEAVE_CRITICAL_SECTION(&csDBL);

	dhp->nRec--;		/* R[h|P */
	dp->updateFlag = 1;	/* t@CXVtOZbg */
	dp->updateCount++;

	if (dhp->nRec == 0)	/* OɂȂꍇ͂aneAdneZbg */
		dbp->eof = dbp->bof = 1;

	/* t@CTCY𒲐 */
	__CHSIZE(dp->fileName, dp->fh, dhp->lHeader + dhp->lRec * dhp->nRec);

	return 0;
}

SHORT	DBDelete3(PDB dbp)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBDelete3(dbp);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBDelete3(PDB dbp)
{
	LONG	currentRecNo, nextRecNo;
	SHORT	eof;
	SHORT	err;

	// ANZX[h`FbN
	if (!(dbp->permission & PERMISSION_WRITE))
		return ERROR_FILE_PERMISSION;

	/* ane܂͂dneȂG[ */
	if (dbp->bof || dbp->eof)
		return ERROR_DB_EOF;

	/* t@CbN`FbN */
	if ((err = _RecordLockCheck(dbp)) != 0)
		return err;

	/* JgR[hԍۑ */
	currentRecNo = dbp->rno;

	/* R[hԍۑ */
	if ((err = _DBSkip(dbp, 1L)) != 0)
		return err;
	nextRecNo = dbp->rno;
	if (nextRecNo == dbp->dp->dhp->nRec)
		nextRecNo = currentRecNo;

	eof = dbp->eof;

	/* JgR[hăZbg */
	if ((err = _DBSet(dbp, currentRecNo)) != 0)
		return err;

	/* R[h̕I폜 */
	if ((err = _DBDelete2(dbp)) != 0)
		return err;

	/* R[hɃR[h|C^Zbg */
	if (eof == 0) {
		if ((err = _DBSet(dbp, nextRecNo)) != 0)
			return err;
	} else
		_CheckEof(dbp, 0L);

	return 0;
}

/*=======================================================================
 |
 |		L[wɂ郌R[h̕I폜
 |
 |	SHORT	DBDeleteKey(dbp, key, len, flag)
 |
 |		PDB	dbp;		ca|C^
 |		CHAR	*key;		폜L[
 |		SHORT	len;		L[̒
 |		SHORT	flag;		OFdL[̓G[
 |					PFdL[폜
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBDeleteKey(PDB dbp, CHAR *key, SHORT len, SHORT flag)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBDeleteKey(dbp, key, len, flag);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBDeleteKey(PDB dbp, CHAR *key, SHORT len, SHORT flag)
{
	LONG	count;
	SHORT	err;

	// ANZX[h`FbN
	if (!(dbp->permission & PERMISSION_WRITE))
		return ERROR_FILE_PERMISSION;

	/* ΏۃR[ho */
	if ((err = _DBCount(dbp, key, len, &count)) != 0)
		return err;

	/* d`FbN */
	if (count == 0) {
		return 0;
	} else if (count > 1) {
		if (flag == 0)
			return ERROR_DB_DBLKEY;
	}

	/* t@CbN`FbN */
	if ((err = _RecordLockCheck(dbp)) != 0)
		return err;


	for (;;) {
		/* 폜R[h */
		if ((err = _DBSearch(dbp, key, len)) != 0)
			return err;

		if (dbp->eof)
			break;

		/* R[h폜 */
		if ((err = _DBDelete2(dbp)) != 0)
			return err;
	}

	return 0;
}

/*=======================================================================
 |
 |		R[h|C^擪R[hɃZbg
 |
 |	SHORT	DBTop(dbp)
 |
 |		PDB	dbp;		ca|C^
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBTop(PDB dbp)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBTop(dbp);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBTop(PDB dbp)
{
	PIDX	ip;
	LONG	rno;
	SHORT	err;

	ip = dbp->ip[dbp->master];

	if (ip == NULL)
		_CheckBof(dbp, 1L);
	else {
		if ((err = IDXTop(ip, &rno)) != 0)
			return err;
		_CheckBof(dbp, rno);
	}

	/* 폜R[hXLbv */
	return _SkipDeleted(dbp, 1);
}

/*=======================================================================
 |
 |		R[h|C^ŏIR[hɃZbg
 |
 |	SHORT	DBBottom(dbp)
 |
 |		PDB	dbp;		ca|C^
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBBottom(PDB dbp)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBBottom(dbp);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBBottom(PDB dbp)
{
	PIDX	ip;
	LONG	rno;
	SHORT	err;

	ip = dbp->ip[dbp->master];

	if (ip == NULL)
		_CheckEof(dbp, dbp->dp->dhp->nRec);
	else {
		if ((err = IDXBottom(ip, &rno)) != 0)
			return err;
		_CheckEof(dbp, rno);
	}

	/* 폜R[hXLbv */
	return _SkipDeleted(dbp, -1);
}

/*=======================================================================
 |
 |		R[h|C^w肳ꂽR[hɃZbg
 |
 |	SHORT	DBSet(dbp, recno)
 |
 |		PDB	dbp;		ca|C^
 |		LONG	recNo;		R[hԍ
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBSet(PDB dbp, LONG recNo)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBSet(dbp, recNo);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBSet(PDB dbp, LONG recNo)
{
	PDBF	dp;
	PIDX	ip;
	LONG	rno;
	SHORT	err;
	CHAR	kbuf[256];
	
	/* |C^Zbg */
	dp = dbp->dp;
	ip = dbp->ip[dbp->master];

	if (ip != NULL) {
		/* CfbNXt@Cꍇ */
		/* R[hǂݍ */
		if ((err = DBFRead2(dp, recNo, dbp->rbp)) != 0)
			return err;

		/* CfbNXt@C̎w肳ꂽR[hԍT */
		if (GetKey(dp, dbp->rbp, ip->ifp->ihp, kbuf) != 0) {
			if ((err = IDXSearch3(ip, kbuf, ip->ifp->ihp->lKey,
							recNo, &rno)) != 0)
				return err;
		}
	}

	_CheckEof(dbp, recNo);	/* dne`FbN */

	return 0;
}

/*=======================================================================
 |
 |		R[h|C^̑Oړ
 |
 |	SHORT	DBSkip(dbp, n)
 |
 |		PDB	dbp;		ca|C^
 |		LONG	n;		ړR[h
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBSkip(PDB dbp, LONG n)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBSkip(dbp, n);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBSkip(PDB dbp, LONG n)
{
	SHORT	err;

	if (dbp->filter == NULL && dbp->select == NULL &&
						dbp->setDeleted == 0) {
		/* R[h|C^ړ */
		if ((err = _Skip(dbp, n)) != 0)
			return err;
	} else {
		if (n < 0) {
			for ( ; n != 0; n++) {
				if ((err = _Skip(dbp, -1L)) != 0)
					return err;
				if ((err = _SkipDeleted(dbp, -1)) != 0)
					return err;
			}
		} else if (n > 0) {
			for ( ; n != 0; n--) {
				if ((err = _Skip(dbp, 1L)) != 0)
					return err;
				if ((err = _SkipDeleted(dbp, 1)) != 0)
					return err;
			}
		}
	}

	return 0;
}

/*=======================================================================
 |
 |		CfbNXt@Cč\z
 |
 |	SHORT	DBReindex(dbp)
 |
 |		PDB	dbp;		ca|C^
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBReindex(PDB dbp)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBReindex(dbp);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBReindex(PDB dbp)
{
	PDBF	dp;
	int	i;
	SHORT	err;

	// ANZX[h`FbN
	if (!(dbp->permission & PERMISSION_WRITE))
		return ERROR_FILE_PERMISSION;

	/* t@CbN`FbN */
	if ((err = _FileLockCheck(dbp)) != 0)
		return err;

	dp = dbp->dp;

	for (i = 1; i <= dbp->nIdx; i++) {
		/* CfbNX\z */
		if ((err = IDXMake(dp, dbp->ip[i])) != 0)
			return err;
	}

	_DBTop(dbp);

	return 0;
}

/*=======================================================================
 |
 |		폜R[ht@Cォ폜
 |
 |	SHORT	DBPack(dbp)
 |
 |		PDB	dbp;		ca|C^
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBPack(PDB dbp)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBPack(dbp);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBPack(PDB dbp)
{
	SHORT	err;

	// ANZX[h`FbN
	if (!(dbp->permission & PERMISSION_WRITE))
		return ERROR_FILE_PERMISSION;

	/* t@CbN`FbN */
	if ((err = _FileLockCheck(dbp)) != 0)
		return err;

	/* 폜R[h̍폜 */
	if ((err = DBFPack(dbp->dp)) != 0)
		return err;

	/* CfbNXt@Cč\z */
	if ((err = _DBReindex(dbp)) != 0)
		return err;

	return 0;
}

/*=======================================================================
 |
 |		JgR[hǂݍ
 |
 |	SHORT	DBRead(dbp, p)
 |
 |		PDB	dbp;		ca|C^
 |		CHAR	*p;		R[hǂݍ݃obt@|C^
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBRead(PDB dbp, CHAR *p)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBRead(dbp, p);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBRead(PDB dbp, CHAR *p)
{
	PDBF	dp;
	PFIELD	flp;
	SHORT	*rfp;
	SHORT	err;

	/* ane܂͂dneȂG[ */
	if (dbp->bof || dbp->eof)
		return ERROR_DB_EOF;

	dp = dbp->dp;

	/* JgR[hǂݍ */
	if (dbp->readField == NULL) {
		if ((err = DBFRead2(dp, dbp->rno, p)) != 0)
			return err;
	} else {
		if ((err = DBFRead2(dp, dbp->rno, dbp->rbp)) != 0)
			return err;
		for (rfp = dbp->readField; *rfp != -1; rfp++) {
			flp = &dp->flp[*rfp];
			memcpy(p, &dbp->rbp[flp->offset], flp->lField2);
			p += flp->lField2;
		}
	}

	return 0;
}

/*=======================================================================
 |
 |		R[hR[hǂݍ
 |
 |	SHORT	DBReadNext(dbp, nRec, p, readRec)
 |
 |		PDB	dbp;		ca|C^
 |		SHORT	nRec;		R[h
 |		CHAR	*p;		R[hǂݍ݃obt@|C^
 |		SHORT	*readRec;	ۂɓǂ񂾃R[h
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBReadNext(PDB dbp, SHORT nRec, CHAR *p, SHORT *readRec)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBReadNext(dbp, nRec, p, readRec);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBReadNext(PDB dbp, SHORT nRec, CHAR *p, SHORT *readRec)
{
	PDBF	dp;
	PFIELD	flp;
	SHORT	*rfp;
	SHORT	err;

	*readRec = 0;
	dp = dbp->dp;

	if ((LONG)dbp->readSize * (LONG)nRec >= 0x10000L)
		return ERROR_DB_PARAMETER;

	while (dbp->eof == 0 && nRec != 0) {
		/* JgR[hǂݍ */
		if (dbp->readField == NULL) {
			if ((err = DBFRead2(dp, dbp->rno, p)) != 0)
				return err;
			p += dp->lRec;
		} else {
			if ((err = DBFRead2(dp, dbp->rno, dbp->rbp)) != 0)
				return err;
			for (rfp = dbp->readField; *rfp != -1; rfp++) {
				flp = &dp->flp[*rfp];
				memcpy(p, &dbp->rbp[flp->offset],
							flp->lField2);
				p += flp->lField2;
			}
		}

		if ((err = _DBSkip(dbp, 1L)) != 0)
			return err;

		(*readRec)++;
		--nRec;
	}

	return 0;
}

/*=======================================================================
 |
 |		OR[hR[hǂݍ
 |
 |	SHORT	DBReadBack(dbp, nRec, p, readRec)
 |
 |		PDB	dbp;		ca|C^
 |		SHORT	nRec;		R[h
 |		CHAR	*p;		R[hǂݍ݃obt@|C^
 |		SHORT	*readRec;	ۂɓǂ񂾃R[h
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBReadBack(PDB dbp, SHORT nRec, CHAR *p, SHORT *readRec)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBReadBack(dbp, nRec, p, readRec);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBReadBack(PDB dbp, SHORT nRec, CHAR *p, SHORT *readRec)
{
	PDBF	dp;
	PFIELD	flp;
	SHORT	*rfp;
	SHORT	err;

	*readRec = 0;
	dp = dbp->dp;

	if ((LONG)dbp->readSize * (LONG)nRec >= 0x10000L)
		return ERROR_DB_PARAMETER;

	while (dbp->bof == 0 && nRec != 0) {
		/* JgR[hǂݍ */
		if (dbp->readField == NULL) {
			if ((err = DBFRead2(dp, dbp->rno, p)) != 0)
				return err;
			p += dp->lRec;
		} else {
			if ((err = DBFRead2(dp, dbp->rno, dbp->rbp)) != 0)
				return err;
			for (rfp = dbp->readField; *rfp != -1; rfp++) {
				flp = &dp->flp[*rfp];
				memcpy(p, &dbp->rbp[flp->offset],
							flp->lField2);
				p += flp->lField2;
			}
		}

		if ((err = _DBSkip(dbp, -1L)) != 0)
			return err;

		(*readRec)++;
		--nRec;
	}

	return 0;
}

/*=======================================================================
 |
 |		L[wɂ郌R[hǂݍ
 |
 |	SHORT	DBReadKey(dbp, key, len, buf, lock, flag)
 |
 |		PDB	dbp;		ca|C^
 |		CHAR	*key;		L[
 |		SHORT	len;		L[
 |		CHAR	*buf;		R[hobt@
 |		SHORT	lock;		OFR[hbNȂ@PF
 |		SHORT	*flag;		OFYR[hȂ@PF
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBReadKey(PDB dbp, CHAR *key, SHORT len, CHAR *buf,
						SHORT lock, SHORT *flag)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBReadKey(dbp, key, len, buf, lock, flag);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBReadKey(PDB dbp, CHAR *key, SHORT len, CHAR *buf,
						SHORT lock, SHORT *flag)
{
	SHORT	err;

	*flag = 0;

	/* R[h */
	if ((err = _DBSearch(dbp, key, len)) != 0)
		return err;

	if (dbp->eof)
		return ERROR_DB_NOKEY;

	/* R[hbN */
	if (lock) {
		if ((err = _DBLock(dbp, LOCK_RECORD_WRITE)) != 0)
			return err;
	}

	if ((err = _DBRead(dbp, buf)) != 0) {
		_DBUnlock(dbp, LOCK_RECORD_WRITE);
		return err;
	}

	*flag = 1;

	return 0;
}

/*=======================================================================
 |
 |		oCif[^ǂݍ
 |
 |	SHORT	DBReadBinary(dbp, field, bufSize, buf, readSize)
 |
 |		PDB	dbp;		ca|C^
 |		CHAR	*field;		tB[h
 |		HPSTR	buf;		f[^obt@
 |		LONG	bufSize;	obt@TCY
 |		LONG	*readSize;	ǂݍ݃f[^TCY
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBReadBinary(PDB dbp, CHAR *field, HPSTR buf, LONG bufSize,
							LONG *readSize)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBReadBinary(dbp, field, buf, bufSize, readSize);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBReadBinary(PDB dbp, CHAR *field, HPSTR buf, LONG bufSize,
								LONG *readSize)
{
	PFIELD	flp;
	CHAR	*fdp;
	LONG	bno;
	SHORT	err;

	*readSize = 0;

	if (field == NULL || field[0] == '\0') {
		if (dbp->brp == NULL)
			return ERROR_DB_NOKEY;

		return BINReadNext(dbp->dp->bfp, dbp->brp, buf, bufSize, readSize);
	}

	/* ane܂͂dneȂG[ */
	if (dbp->bof || dbp->eof)
		return ERROR_DB_EOF;

	/* JgR[hǂݍ */
	if ((err = DBFRead(dbp->dp, dbp->rno, dbp->rbp)) != 0)
		return err;

	/* tB[ho */
	if ((flp = GetField(dbp->dp, field)) == NULL)
		return ERROR_DB_NOKEY;

	/* tB[h^Cv`FbN */
	if (flp->type != 'B')
		return ERROR_DB_NOKEY;

	fdp = &dbp->rbp[flp->offset + 1];
	bno = *(LONG *)fdp;

	if (bno != 0) {
		if (dbp->brp == NULL) {
			if ((dbp->brp = malloc(sizeof(BIN_R))) == NULL)
				return ERROR_DB_MEMORY;
		}

		if ((err = BINRead(dbp->dp->bfp, dbp->brp, buf, bufSize, bno, readSize)) != 0)
			return err;
	}

	return 0;
}

/*=======================================================================
 |
 |		oCif[^
 |
 |	SHORT	DBWriteBinary(dbp, field, buf, bufSize)
 |
 |		PDB	dbp;		ca|C^
 |		CHAR	*field;		tB[h
 |		HPSTR	buf;		f[^obt@
 |		LONG	bufSize;	obt@TCY
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBWriteBinary(PDB dbp, CHAR *field, HPSTR buf, LONG bufSize)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBWriteBinary(dbp, field, buf, bufSize);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBWriteBinary(PDB dbp, CHAR *field, HPSTR buf, LONG bufSize)
{
	PBIN	bfp;
	PFIELD	flp;
	CHAR	*fdp;
	LONG	bno;
	BOOL	bClear;
	SHORT	err;

	// ANZX[h`FbN
	if (!(dbp->permission & PERMISSION_WRITE))
		return ERROR_FILE_PERMISSION;

	if (field == NULL || field[0] == '\0')
		return BINWriteNext(dbp->dp->bfp, buf, bufSize);

	/* ane܂͂dneȂG[ */
	if (dbp->bof || dbp->eof)
		return ERROR_DB_EOF;

	/* JgR[hǂݍ */
	if ((err = DBFRead(dbp->dp, dbp->rno, dbp->rbp)) != 0)
		return err;

	/* f[^NA`FbN */
	if (field[0] == '*') {
		bClear = FALSE;
		field++;
	} else
		bClear = TRUE;

	/* tB[ho */
	if ((flp = GetField(dbp->dp, field)) == NULL)
		return ERROR_DB_NOKEY;

	/* tB[h^Cv`FbN */
	if (flp->type != 'B')
		return ERROR_DB_NOKEY;

	fdp = &dbp->rbp[flp->offset + 1];
	bno = *(LONG *)fdp;

	bfp = dbp->dp->bfp;

	if (bno != 0 && bClear) {
		if ((err = BINDelete(bfp, bno)) != 0)
			return err;
		bno = 0;
	}

	if ((err = BINWrite(bfp, buf, bufSize, &bno)) != 0)
		return err;

	*(LONG *)fdp = bno;

	/* JgR[h */
	if ((err = DBFWrite(dbp->dp, dbp->rno, dbp->rbp)) != 0)
		return err;

	return 0;
}

/*=======================================================================
 |
 |		oCif[^TCY擾
 |
 |	SHORT	DBGetBinarySize(dbp, field, dataSize)
 |
 |		PDB	dbp;		ca|C^
 |		CHAR	*field;		tB[h
 |		LONG	*dataSize;	ǂݍ݃f[^TCY
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBGetBinarySize(PDB dbp, CHAR *field, LONG *dataSize)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBGetBinarySize(dbp, field, dataSize);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBGetBinarySize(PDB dbp, CHAR *field, LONG *dataSize)
{
	PFIELD	flp;
	CHAR	*fdp;
	LONG	bno;
	SHORT	err;

	*dataSize = 0;

	/* ane܂͂dneȂG[ */
	if (dbp->bof || dbp->eof)
		return ERROR_DB_EOF;

	/* JgR[hǂݍ */
	if ((err = DBFRead(dbp->dp, dbp->rno, dbp->rbp)) != 0)
		return err;

	/* tB[ho */
	if ((flp = GetField(dbp->dp, field)) == NULL)
		return ERROR_DB_NOKEY;

	/* tB[h^Cv`FbN */
	if (flp->type != 'B')
		return ERROR_DB_NOKEY;

	fdp = &dbp->rbp[flp->offset + 1];
	bno = *(LONG *)fdp;

	if (bno == 0)	
		*dataSize = 0;
	else {
		if ((err = BINGetDataSize(dbp->dp->bfp, bno, dataSize)) != 0)
			return err;
	}

	return 0;
}

/*=======================================================================
 |
 |		R[hobt@NA
 |
 |	SHORT	DBClrRecord(dbp)
 |
 |		PDB	dbp;		ca|C^
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBClrRecord(PDB dbp)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBClrRecord(dbp);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBClrRecord(PDB dbp)
{
	memset(dbp->rbp2, ' ', dbp->dp->lRec);	/* obt@NA */

	return 0;
}

/*=======================================================================
 |
 |		R[hobt@ǂݍ
 |
 |	SHORT	DBGetRecord(dbp)
 |
 |		PDB	dbp;		ca|C^
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBGetRecord(PDB dbp)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBGetRecord(dbp);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBGetRecord(PDB dbp)
{
	SHORT	err;

	/* ane܂͂dneȂG[ */
	if (dbp->bof || dbp->eof)
		return ERROR_DB_EOF;

	/* JgR[hǂݍ */
	if ((err = DBFRead2(dbp->dp, dbp->rno, dbp->rbp2)) != 0)
		return err;

	return 0;
}

/*=======================================================================
 |
 |		tB[hf[^ǂݍ
 |
 |	SHORT	DBGetField(dbp, field, bufp, fieldType, dataSize)
 |
 |		PDB	dbp;		ca|C^
 |		CHAR	*field;		tB[h
 |		VOID	*bufp;		tB[hobt@
 |		SHORT	*fieldType;	tB[ȟ^
 |		SHORT	*dataSize;	tB[hf[^
 |
 |		Ԓl			G[R[h
 |	
 =======================================================================*/
SHORT	DBGetField(PDB dbp, CHAR *field, VOID *bufp, SHORT *fieldType,
							SHORT *dataSize)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBGetField(dbp, field, bufp, fieldType, dataSize);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBGetField(PDB dbp, CHAR *field, VOID *bufp, SHORT *fieldType,
							SHORT *dataSize)
{
	PFIELD	flp;
	SHORT	len;
	CHAR	*fdp;

	*dataSize = 0;

	/* tB[ho */
	if ((flp = GetField(dbp->dp, field)) == NULL)
		return ERROR_DB_NOKEY;

	fdp = &dbp->rbp2[flp->offset];

	/* tB[hf[^ꂼ̌^ɕϊ */
	switch (flp->type) {
	case 'C':
	case 'D':
	case 'L':
		for (len = flp->lField2; len != 0; len--) {
			if (fdp[len - 1] != ' ')
				break;
		}
		memcpy(bufp, fdp, len);
		((CHAR *)bufp)[len] = '\0';
		*dataSize = len + 1;
		break;
	case 'N':
		*(double *)bufp = natof(fdp, flp->lField2);
		*dataSize = sizeof(double);
		break;
	case 'I':
		*(LONG *)bufp = natol(fdp, flp->lField2);
		*dataSize = sizeof(LONG);
		break;
	default:
		return ERROR_DB_NOKEY;
		break;
	}

	*fieldType = flp->type;

	return 0;
}

/*=======================================================================
 |
 |		tB[hf[^
 |
 |	SHORT	DBSetField(dbp, field, bufp)
 |
 |		PDB	dbp;		ca|C^
 |		CHAR	*field;		tB[h
 |		VOID	*bufp;		tB[hobt@
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBSetField(PDB dbp, CHAR *field, VOID *bufp)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBSetField(dbp, field, bufp);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBSetField(PDB dbp, CHAR *field, VOID *bufp)
{
	PFIELD	flp;
	SHORT	len;
	CHAR	*fdp;
	CHAR	fmt[20];
	CHAR	buf[128];

	/* tB[ho */
	if ((flp = GetField(dbp->dp, field)) == NULL)
		return ERROR_DB_NOKEY;

	fdp = &dbp->rbp2[flp->offset];

	/* e^̃f[^𕶎ɕϊ */
	switch (flp->type) {
	case 'C':
	case 'D':
	case 'L':
		len = strlen(bufp);
		if (len > flp->lField2)
			len = flp->lField2;
		memcpy(fdp, bufp, len);
		if (len < flp->lField2)
			memset(fdp + len, ' ', flp->lField2 - len);
		break;
	case 'N':
		sprintf(fmt, "%%%d.%dlf", flp->lField2, flp->lDec);
		sprintf(buf, fmt, *(double *)bufp);
		memcpy(fdp, buf, flp->lField2);
		break;
	case 'I':
		sprintf(fmt, "%%%dld", flp->lField2);
		sprintf(buf, fmt, *(LONG *)bufp);
		memcpy(fdp, buf, flp->lField2);
		break;
	default:
		return ERROR_DB_NOKEY;
		break;
	}

	return 0;
}

/*=======================================================================
 |
 |		R[hǉ
 |
 |	SHORT	DBAddRecord(dbp)
 |
 |		PDB	dbp;		ca|C^
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBAddRecord(PDB dbp)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBAddRecord(dbp);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBAddRecord(PDB dbp)
{
	return _DBStore(dbp, dbp->rbp2);	/* R[hǉ */
}

/*=======================================================================
 |
 |		R[hXV
 |
 |	SHORT	DBUpdRecord(dbp)
 |
 |		PDB	dbp;		ca|C^
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBUpdRecord(PDB dbp)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBUpdRecord(dbp);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBUpdRecord(PDB dbp)
{
	return _DBUpdate(dbp, dbp->rbp2);	/* R[hXV */
}

/*=======================================================================
 |
 |		f[^t@C̃Rs[
 |
 |	SHORT	DBCopy(dbp1, dbp2)
 |
 |		PDB	dbp1;		Rs[ca|C^
 |		PDB	dbp2;		Rs[ca|C^
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBCopy(PDB dbp1, PDB dbp2)
{
	SHORT	err;

	// ANZX[h`FbN
	if (!(dbp2->permission & PERMISSION_WRITE))
		return ERROR_FILE_PERMISSION;

	/* f[^t@CRs[ */
	if ((err = DBFCopy(dbp1->dp, dbp2->dp)) != 0)
		return err;

	/* CfbNXt@Cč\z */
	return _DBReindex(dbp2);
}

/*=======================================================================
 |
 |		폜R[h`FbN
 |
 |	SHORT	DBCheckDeleted(dbp, flag)
 |
 |		PDB	dbp;		ca|C^
 |		SHORT	*flag;		OFʏ탌R[h@PF폜R[h
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBCheckDeleted(PDB dbp, SHORT *flag)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBCheckDeleted(dbp, flag);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBCheckDeleted(PDB dbp, SHORT *flag)
{
	/* ane܂͂dneȂG[ */
	if (dbp->bof || dbp->eof)
		return ERROR_DB_EOF;

	return DBFCheckDeleted(dbp->dp, dbp->rno, flag);
}

/*=======================================================================
 |
 |		tB^ݒ
 |
 |	SHORT	DBSetFilter(dbp, filter)
 |
 |		PDB	dbp;		ca|C^
 |		CHAR	*filter;	tB^
 |					iNULL ̏ꍇ̓tB^j
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBSetFilter(PDB dbp, CHAR *filter)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBSetFilter(dbp, filter);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBSetFilter(PDB dbp, CHAR *filter)
{
	int	len;
	SHORT	err;

	if (dbp->filter != NULL) {
		free(dbp->filter);
		dbp->filter = NULL;
	}

	if (filter != NULL) {
		len = strlen(filter);
		if (strlen(filter) != 0) {
			if ((err = SetFilter(dbp, filter)) != 0)
				return err;
		}
	}

	return _DBTop(dbp);		/* 擪R[h */
}

/*=======================================================================
 |
 |		Iݒ
 |
 |	SHORT	DBSelect(dbp, select, nRec)
 |
 |		PDB	dbp;		ca|C^
 |		CHAR	*select;	I
 |		LONG	*nRec;		IR[h
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBSelect(PDB dbp, CHAR *select, LONG *nRec)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBSelect(dbp, select, nRec);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBSelect(PDB dbp, CHAR *select, LONG *nRec)
{
	int	len;
	SHORT	err;

	*nRec = 0;

	if (dbp->select != NULL) {
		HFREE(dbp->select);
		dbp->select = NULL;
	}

	if (select != NULL) {
		len = strlen(select);
		if (strlen(select) != 0) {
			if ((err = SetSelect(dbp, select, nRec)) != 0)
				return err;
		}
	}

	return _DBTop(dbp);		/* 擪R[h */
}

/*=======================================================================
 |
 |		폜R[hL^̐ݒ
 |
 |	SHORT	DBSetDeleted(dbp, flag)
 |
 |		PDB	dbp;		ca|C^
 |		SHORT	flag;		OF폜R[hL
 |					PF폜R[h
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBSetDeleted(PDB dbp, SHORT flag)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBSetDeleted(dbp, flag);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBSetDeleted(PDB dbp, SHORT flag)
{
	dbp->setDeleted = flag;
	return _DBTop(dbp);		/* 擪R[h */
}

/*=======================================================================
 |
 |		JgR[h̘_R[hԍo
 |
 |	SHORT	DBLRecNo(dbp, recNo)
 |
 |		PDB	dbp;		ca|C^
 |		LONG	*recNo;		_R[hԍ
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBLRecNo(PDB dbp, LONG *recNo)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBLRecNo(dbp, recNo);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBLRecNo(PDB dbp, LONG *recNo)
{
	LONG	pRecNo, lRecNo;
	SHORT	err;

	if (dbp->bof || dbp->eof)
		return ERROR_DB_EOF;

	_DBRecNo(dbp, &pRecNo);
	_DBTop(dbp);
	for (lRecNo = 1; pRecNo != dbp->rno; lRecNo++) {
		if (dbp->eof)
			return 0L;
		if ((err = _DBSkip(dbp, 1L)) != 0)
			return err;
	}

	*recNo = lRecNo;

	return 0;
}

/*=======================================================================
 |
 |		_R[ho
 |
 |	LONG	DBLRecCount(dbp, nRec)
 |
 |		PDB	dbp;		ca|C^
 |		LONG	*nRec;		_R[h
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBLRecCount(PDB dbp, LONG *nRec)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBLRecCount(dbp, nRec);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBLRecCount(PDB dbp, LONG *nRec)
{
	LONG	count;
	SHORT	bof;
	SHORT	eof;
	LONG	rno;
	SHORT	master;
	SHORT	err;

	if (dbp->filter == NULL && dbp->select == NULL && dbp->setDeleted == 0)
		*nRec = dbp->dp->dhp->nRec;
	else {
		bof = dbp->bof;
		eof = dbp->eof;
		rno = dbp->rno;
		master = dbp->master;
		dbp->master = 0;

		_DBTop(dbp);
		for (count = 0; dbp->eof == 0; count++) {
			if ((err = _DBSkip(dbp, 1L)) != 0)
				return err;
		}

		dbp->bof = bof;
		dbp->eof = eof;
		dbp->rno = rno;
		dbp->master = master;

		*nRec = count;
	}

	return 0;
}

/*=======================================================================
 |
 |		_R[hԍɂJgR[h̐ݒ
 |
 |	SHORT	DBLSet(dbp, lRecNo)
 |
 |		PDB	dbp;		ca|C^
 |		LONG	lRecNo;		_R[hԍ
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBLSet(PDB dbp, LONG lRecNo)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBLSet(dbp, lRecNo);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBLSet(PDB dbp, LONG lRecNo)
{
	SHORT	err;

	if ((err = _DBTop(dbp)) != 0)
		return err;

	return _DBSkip(dbp, lRecNo - 1);
}

/*=======================================================================
 |
 |		SR[h폜
 |
 |	SHORT	DBZip(dbp)
 |
 |		PDB	dbp;		ca|C^
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBZip(PDB dbp)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBZip(dbp);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBZip(PDB dbp)
{
	SHORT	err;

	// ANZX[h`FbN
	if (!(dbp->permission & PERMISSION_WRITE))
		return ERROR_FILE_PERMISSION;

	/* t@CbN`FbN */
	if ((err = _FileLockCheck(dbp)) != 0)
		return err;

	/* f[^t@CSR[h폜 */
	if ((err = DBFZip(dbp->dp)) != 0)
		return err;

	/* CfbNXč\z */
	return _DBReindex(dbp);
}

/*=======================================================================
 |
 |		XV`FbN
 |
 |	SHORT	DBCheckUpdate(dbp, updateFlag)
 |
 |		PDB	dbp;		ca|C^
 |		SHORT	*updateFlag;	OFXVȂ@PFXV
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBCheckUpdate(PDB dbp, SHORT *updateFlag)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBCheckUpdate(dbp, updateFlag);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBCheckUpdate(PDB dbp, SHORT *updateFlag)
{
	*updateFlag = (dbp->updateCount != dbp->dp->updateCount) ? 1 : 0;
	dbp->updateCount = dbp->dp->updateCount;

	return 0;
}

/*=======================================================================
 |
 |		t@C^R[hbN
 |
 |	SHORT	DBLock(dbp, lock)
 |
 |		PDB	dbp;		ca|C^
 |		SHORT	lock;		OFt@CbN@PFR[hbN
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBLock(PDB dbp, SHORT lock)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBLock(dbp, lock);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBLock(PDB dbp, SHORT lock)
{
	PDBF	dp;
	PDBLOCK	dlp;

	dp = dbp->dp;
	switch (lock) {
	case LOCK_FILE_WRITE:
		if (dbp->writeLockCount != 0) {
			dbp->writeLockCount++;
			break;
		}

		/* t@CbN`FbN */
		if (dp->readLockCount != 0 || dp->writeLockCount != 0)
			return ERROR_DB_LOCK;

		ENTER_CRITICAL_SECTION(&csDBL);

		/* ǂݍ݃R[hbN`FbN */
		for (dlp = dp->rdlp; dlp != NULL; dlp = dlp->chain) {
			if (dlp->dbp != dbp) {
				LEAVE_CRITICAL_SECTION(&csDBL);
				return ERROR_DB_LOCK;
			}
		}

		/* ݃R[hbN`FbN */
		for (dlp = dp->wdlp; dlp != NULL; dlp = dlp->chain) {
			if (dlp->dbp != dbp) {
				LEAVE_CRITICAL_SECTION(&csDBL);
				return ERROR_DB_LOCK;
			}
		}

		LEAVE_CRITICAL_SECTION(&csDBL);

		dbp->writeLockCount++;
		dp->writeLockCount++;
		break;
	case LOCK_RECORD_WRITE:
		/* ane܂͂dneȂG[ */
		if (dbp->bof || dbp->eof)
			return ERROR_DB_EOF;

		/* t@CbN`FbN */
		if (dp->readLockCount != 0 ||
					(dp->writeLockCount != 0 &&
					dbp->writeLockCount == 0))
			return ERROR_DB_LOCK;

		ENTER_CRITICAL_SECTION(&csDBL);

		/* ǂݍ݃R[hbN`FbN */
		for (dlp = dp->rdlp; dlp != NULL; dlp = dlp->chain) {
			if (dlp->rno == dbp->rno) {
				LEAVE_CRITICAL_SECTION(&csDBL);
				return ERROR_DB_LOCK;
			}
		}

		/* ݃R[hbN`FbN */
		for (dlp = dp->wdlp; dlp != NULL; dlp = dlp->chain) {
			if (dlp->rno == dbp->rno) {
				if (dlp->dbp != dbp) {
					LEAVE_CRITICAL_SECTION(&csDBL);
					return ERROR_DB_LOCK;
				}
				break;
			}
		}

		if (dlp == NULL) {
			if ((dlp = malloc(sizeof(DBLOCK))) == NULL) {
				LEAVE_CRITICAL_SECTION(&csDBL);
				return ERROR_DB_MEMORY;
			}
			memset(dlp, 0, sizeof(DBLOCK));

			dlp->dbp = dbp;
			dlp->rno = dbp->rno;

			dlp->chain = dp->wdlp;
			dp->wdlp = dlp;
		}

		LEAVE_CRITICAL_SECTION(&csDBL);
		break;
	case LOCK_FILE_READ:
		if (dbp->readLockCount != 0) {
			dbp->readLockCount++;
			break;
		}

		/* t@CbN`FbN */
		if (dp->writeLockCount != 0)
			return ERROR_DB_LOCK;

		ENTER_CRITICAL_SECTION(&csDBL);

		/* ݃R[hbN`FbN */
		if (dp->wdlp != NULL) {
			LEAVE_CRITICAL_SECTION(&csDBL);
			return ERROR_DB_LOCK;
		}

		LEAVE_CRITICAL_SECTION(&csDBL);

		dbp->readLockCount++;
		dp->readLockCount++;
		break;
	case LOCK_RECORD_READ:
		/* ane܂͂dneȂG[ */
		if (dbp->bof || dbp->eof)
			return ERROR_DB_EOF;

		/* t@CbN`FbN */
		if (dp->writeLockCount != 0)
			return ERROR_DB_LOCK;

		ENTER_CRITICAL_SECTION(&csDBL);

		/* ݃R[hbN`FbN */
		for (dlp = dp->wdlp; dlp != NULL; dlp = dlp->chain) {
			if (dlp->rno == dbp->rno) {
				LEAVE_CRITICAL_SECTION(&csDBL);
				return ERROR_DB_LOCK;
			}
		}

		for (dlp = dp->rdlp; dlp != NULL; dlp = dlp->chain) {
			if (dlp->rno == dbp->rno)
				break;
		}

		if (dlp == NULL) {
			if ((dlp = malloc(sizeof(DBLOCK))) == NULL) {
				LEAVE_CRITICAL_SECTION(&csDBL);
				return ERROR_DB_MEMORY;
			}
			memset(dlp, 0, sizeof(DBLOCK));

			dlp->dbp = dbp;
			dlp->rno = dbp->rno;

			dlp->chain = dp->rdlp;
			dp->rdlp = dlp;
		}

		LEAVE_CRITICAL_SECTION(&csDBL);
		break;
	default:
		return ERROR_DB_PARAMETER;
	}

	return 0;
}

/*=======================================================================
 |
 |		t@C^R[hbN
 |
 |	SHORT	DBUnlock(dbp, lock)
 |
 |		PDB	dbp;		ca|C^
 |		SHORT	lock;		OFt@CbN@PFR[hbN
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBUnlock(PDB dbp, SHORT lock)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBUnlock(dbp, lock);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBUnlock(PDB dbp, SHORT lock)
{
	PDBF	dp;
	PDBLOCK	chain, *dlpp;

	dp = dbp->dp;

	switch (lock) {
	case LOCK_FILE_WRITE:
		if (dbp->writeLockCount != 0) {
			if (--dbp->writeLockCount == 0) {
				if (dp->writeLockCount > 0)
					dp->writeLockCount--;
			}
		}
		break;
	case LOCK_RECORD_WRITE:
		ENTER_CRITICAL_SECTION(&csDBL);
		for (dlpp = &dp->wdlp; *dlpp != 0; ) {
			if ((*dlpp)->dbp == dbp) {
				chain = (*dlpp)->chain;
				free(*dlpp);
				*dlpp = chain;
			} else
				dlpp = &(*dlpp)->chain;
		}
		LEAVE_CRITICAL_SECTION(&csDBL);
		break;
	case LOCK_FILE_READ:
		if (dbp->readLockCount != 0) {
			if (--dbp->readLockCount == 0) {
				if (dp->readLockCount > 0)
					dp->readLockCount--;
			}
		}
		break;
	case LOCK_RECORD_READ:
		ENTER_CRITICAL_SECTION(&csDBL);
		for (dlpp = &dp->rdlp; *dlpp != 0; ) {
			if ((*dlpp)->dbp == dbp) {
				chain = (*dlpp)->chain;
				free(*dlpp);
				*dlpp = chain;
			} else
				dlpp = &(*dlpp)->chain;
		}
		LEAVE_CRITICAL_SECTION(&csDBL);
		break;
	default:
		return ERROR_DB_PARAMETER;
	}

	return 0;
}

/*=======================================================================
 |
 |		R[ho
 |
 |	SHORT	DBRecCount(dbp, nRec)
 |
 |		PDB	dbp;		ca|C^
 |		LONG	*nRec;		R[h
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBRecCount(PDB dbp, LONG *nRec)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBRecCount(dbp, nRec);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBRecCount(PDB dbp, LONG *nRec)
{
	*nRec = dbp->dp->dhp->nRec;

	return 0;
}

/*=======================================================================
 |
 |		ane`FbN
 |
 |	SHORT	DBBof(dbp, bof)
 |
 |		PDB	dbp;		ca|C^
 |		SHORT	*bof;		OFanełȂ@PFane
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBBof(PDB dbp, SHORT *bof)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBBof(dbp, bof);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBBof(PDB dbp, SHORT *bof)
{
	*bof = dbp->bof;

	return 0;
}

/*=======================================================================
 |
 |		f[^t@Co
 |
 |	SHORT	DBDbf(dbp, fileName)
 |
 |		PDB	dbp;		ca|C^
 |		CHAR	*fileName;	f[^t@C
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBDbf(PDB dbp, CHAR *fileName)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBDbf(dbp, fileName);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBDbf(PDB dbp, CHAR *fileName)
{
	strcpy(fileName, dbp->dp->fileName);

	return 0;
}

/*=======================================================================
 |
 |		dne`FbN
 |
 |	SHORT	DBEof(dbp, eof)
 |
 |		PDB	dbp;		ca|C^
 |		SHORT	*eof;		OFdnełȂ@PFdne
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBEof(PDB dbp, SHORT *eof)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBEof(dbp, eof);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBEof(PDB dbp, SHORT *eof)
{
	*eof = dbp->eof;

	return 0;
}

/*=======================================================================
 |
 |		tB[h擾
 |
 |	SHORT	DBNField(dbp, nField)
 |
 |		PDB	dbp;		ca|C^
 |		SHORT	*nField;	tB[h
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBNField(PDB dbp, SHORT *nField)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBNField(dbp, nField);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBNField(PDB dbp, SHORT *nField)
{
	*nField = dbp->dp->nField;

	return 0;
}

/*=======================================================================
 |
 |		tB[ho
 |
 |	SHORT	DBField(dbp, n, dip)
 |
 |		PDB	dbp;		ca|C^
 |		SHORT	n;		tB[hԍ
 |		PDBF_I	dip;		tB[h
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBField(PDB dbp, SHORT n, PDBF_I dip)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBField(dbp, n, dip);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBField(PDB dbp, SHORT n, PDBF_I dip)
{
	PDBF	dp;
	PFIELD	flp;

	dp = dbp->dp;
	if (n < 1 || n > dp->nField)
		return ERROR_DB_PARAMETER;

	flp = &dp->flp[n - 1];
	strcpy(dip->name, flp->name);
	dip->type = flp->type;
	dip->lField = (flp->type == 'B') ? 0 : flp->lField2;
	dip->lDec = flp->lDec;

	return 0;
}

/*=======================================================================
 |
 |		CfbNXt@Co
 |
 |	SHORT	DBNdx(dbp, n, fileName)
 |
 |		PDB	dbp;		ca|C^
 |		SHORT	n;		CfbNXt@Cԍ
 |		CHAR	*fileName;	CfbNXt@C
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBNdx(PDB dbp, SHORT n, CHAR *fileName)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBNdx(dbp, n, fileName);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBNdx(PDB dbp, SHORT n, CHAR *fileName)
{
	fileName[0] = '\0';

	if (n < 1 || n > dbp->nIdx)
		return ERROR_DB_PARAMETER;

	strcpy(fileName, dbp->ip[n]->ifp->fileName);

	return 0;
}

/*=======================================================================
 |
 |		JgR[hԍo
 |
 |	SHORT	DBRecNo(dbp, recNo)
 |
 |		PDB	dbp;		ca|C^
 |		LONG	*renNo;		JgR[hԍ
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBRecNo(PDB dbp, LONG *recNo)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBRecNo(dbp, recNo);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBRecNo(PDB dbp, LONG *recNo)
{
	*recNo = dbp->rno;

	return 0;
}

/*=======================================================================
 |
 |		R[ho
 |
 |	SHORT	DBRecSize(dbp, lRec)
 |
 |		PDB	dbp;		ca|C^
 |		SHORT	*lRec;		R[h
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBRecSize(PDB dbp, SHORT *lrec)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBRecSize(dbp, lrec);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBRecSize(PDB dbp, SHORT *lrec)
{
	*lrec = dbp->dp->lRec + 1;

	return 0;
}

/*=======================================================================
 |
 |		ǂݍ݃tB[hݒ
 |
 |	SHORT	DBSetReadField(dbp, readField, length)
 |
 |		PDB	dbp;		ca|C^
 |		CHAR	*readField;	ǂݍ݃tB[h
 |		SHORT	*length;	f[^
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBSetReadField(PDB dbp, CHAR *readField, SHORT *length)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBSetReadField(dbp, readField, length);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBSetReadField(PDB dbp, CHAR *readField, SHORT *length)
{
	PDBF	dp;
	CHAR	*p;
	int	count;
	SHORT	fieldNo;
	SHORT	*sp;
	CHAR	*wp;

	dp = dbp->dp;

	if (dbp->readField != NULL) {
		free(dbp->readField);
		dbp->readField = NULL;
		dbp->readSize = dp->lRec;
	}

	if (readField != NULL && readField[0] != '\0') {
		if ((sp = (SHORT *)malloc(1000 * sizeof(SHORT))) == NULL)
			return ERROR_DB_MEMORY;
		if ((wp = malloc(strlen(readField) + 1)) == NULL) {
			free(sp);
			return ERROR_DB_MEMORY;
		}
		dbp->readSize = 0;
		count = 0;
		strcpy(wp, readField);
		p = strtok(wp, "+ ");
		while (p) {
			if ((fieldNo = GetFieldNo(dp, p)) == -1) {
				free(sp);
				free(wp);
				return ERROR_DB_PARAMETER;
			}

			sp[count++] = fieldNo;
			dbp->readSize += dp->flp[fieldNo].lField2;
			p = strtok(NULL, "+ ");
		}
		free(wp);
		sp[count++] = -1;
		if ((dbp->readField = (SHORT *)realloc(sp,
					count * sizeof(SHORT))) == NULL) {
			free(sp);
			return ERROR_DB_MEMORY;
		}
	} else
		dbp->readSize = dbp->dp->lRec;

	*length = dbp->readSize;

	return 0;
}

/*=======================================================================
 |
 |		ÍL[ݒ
 |
 |	SHORT	DBSetScramble(dbp)
 |
 |		PDB	dbp;		ca|C^
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBSetScramble(PDB dbp)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBSetScramble(dbp);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBSetScramble(PDB dbp)
{
	long	ltime;
	USHORT	scramble;

	// ANZX[h`FbN
	if (!(dbp->permission & PERMISSION_WRITE))
		return ERROR_FILE_PERMISSION;

	time(&ltime);
	scramble = (USHORT)ltime;
	if (scramble == 0)
		scramble = 1;

	return DBFSetScramble(dbp->dp, scramble);
}

/*=======================================================================
 |
 |		pX[hݒ
 |
 |	SHORT	DBSetPassword(dbp, password)
 |
 |		PDB	dbp;		ca|C^
 |		CHAR	*password;	pX[h
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBSetPassword(PDB dbp, CHAR *password)
{
	// ANZX[h`FbN
	if (!(dbp->permission & PERMISSION_WRITE))
		return ERROR_FILE_PERMISSION;

	return DBFSetPassword(dbp->dp, password);
}

/*=======================================================================
 |
 |		R[hԍwɂ郌R[hXV
 |
 |	SHORT	DBUpdateEx(dbp, recNo, rec)
 |
 |		PDB	dbp;		ca|C^
 |		LONG	recNo;		R[hԍ
 |		CHAR	*rec;		XV郌R[hf[^ւ̃|C^
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBUpdateEx(PDB dbp, LONG recNo, CHAR *rec)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBUpdateEx(dbp, recNo, rec);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBUpdateEx(PDB dbp, LONG recNo, CHAR *rec)
{
	SHORT	err;

	// ANZX[h`FbN
	if (!(dbp->permission & PERMISSION_WRITE))
		return ERROR_FILE_PERMISSION;

	/* JgR[hZbg */
	if ((err = _DBSet(dbp, recNo)) != 0)
		return err;

	return _DBUpdate(dbp, rec);
}

/*=======================================================================
 |
 |		R[hԍwɂ郌R[h폜
 |
 |	SHORT	DBDeleteEx(dbp, recNo)
 |
 |		PDB	dbp;		ca|C^
 |		LONG	recNo;		R[hԍ
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBDeleteEx(PDB dbp, LONG recNo)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBDeleteEx(dbp, recNo);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBDeleteEx(PDB dbp, LONG recNo)
{
	SHORT	err;

	// ANZX[h`FbN
	if (!(dbp->permission & PERMISSION_WRITE))
		return ERROR_FILE_PERMISSION;

	/* JgR[hZbg */
	if ((err = _DBSet(dbp, recNo)) != 0)
		return err;

	return _DBDelete(dbp);
}

/*=======================================================================
 |
 |		R[hԍwɂ郌R[h
 |
 |	SHORT	DBRecallEx(dbp, recNo)
 |
 |		PDB	dbp;		ca|C^
 |		LONG	recNo;		R[hԍ
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBRecallEx(PDB dbp, LONG recNo)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBRecallEx(dbp, recNo);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBRecallEx(PDB dbp, LONG recNo)
{
	SHORT	err;

	// ANZX[h`FbN
	if (!(dbp->permission & PERMISSION_WRITE))
		return ERROR_FILE_PERMISSION;

	/* JgR[hZbg */
	if ((err = _DBSet(dbp, recNo)) != 0)
		return err;

	return _DBRecall(dbp);
}

/*=======================================================================
 |
 |		R[hԍwɂ镨R[h폜
 |
 |	SHORT	DBDelete2Ex(dbp, recNo)
 |
 |		PDB	dbp;		ca|C^
 |		LONG	recNo;		R[hԍ
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBDelete2Ex(PDB dbp, LONG recNo)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBDelete2Ex(dbp, recNo);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBDelete2Ex(PDB dbp, LONG recNo)
{
	SHORT	err;

	// ANZX[h`FbN
	if (!(dbp->permission & PERMISSION_WRITE))
		return ERROR_FILE_PERMISSION;

	/* JgR[hZbg */
	if ((err = _DBSet(dbp, recNo)) != 0)
		return err;

	return _DBDelete2(dbp);
}

/*=======================================================================
 |
 |		R[hԍwɂ郌R[h^t@CbN
 |
 |	SHORT	DBLockEx(dbp, recNo, lock)
 |
 |		PDB	dbp;		ca|C^
 |		LONG	recNo;		R[hԍ
 |		SHORT	lock;		OFt@CbN@PFR[hbN
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBLockEx(PDB dbp, LONG recNo, SHORT lock)
{
	SHORT	err;

	ENTER_CRITICAL_SECTION(&dbp->dp->csDBF);
	err = _DBLockEx(dbp, recNo, lock);
	LEAVE_CRITICAL_SECTION(&dbp->dp->csDBF);

	return err;
}

static	SHORT	_DBLockEx(PDB dbp, LONG recNo, SHORT lock)
{
	SHORT	err;

	/* JgR[hZbg */

	if (lock == LOCK_RECORD_WRITE || lock == LOCK_RECORD_READ) {
		if ((err = _DBSet(dbp, recNo)) != 0)
			return err;
	}

	return _DBLock(dbp, lock);
}

/*=======================================================================
 |
 |		CfbNXt@C̃pbN
 |
 |	SHORT	DBPackIndex(fileName)
 |
 |		CHAR	*fileName;	CfbNXt@C
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
SHORT	DBPackIndex(CHAR *fileName)
{
	PIDX	ip;
	SHORT	err;

	/* CfbNXt@CI[v */
	if ((err = IDXOpen(fileName, &ip)) != 0)
		return err;

	err = IDXPack(ip);

	IDXClose(ip);

	return err;
}

/*=======================================================================
 |
 |		t@CbN`FbN
 |
 |	SHORT	_FileLockCheck(dbp)
 |
 |		PDB	dbp;		ca|C^
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
static	SHORT	_FileLockCheck(PDB dbp)
{
	PDBF	dp;
	PDBLOCK	dlp;

	dp = dbp->dp;

	/* t@CbN`FbN */
	if (dp->readLockCount != 0 ||
			(dp->writeLockCount != 0 && dbp->writeLockCount == 0))
		return ERROR_DB_LOCK;

	ENTER_CRITICAL_SECTION(&csDBL);

	/* ǂݍ݃R[hbN`FbN */
	if (dp->rdlp != NULL) {
		LEAVE_CRITICAL_SECTION(&csDBL);
		return ERROR_DB_LOCK;
	}

	/* ݃R[hbN`FbN */
	for (dlp = dp->wdlp; dlp != NULL; dlp = dlp->chain) {
		if (dlp->dbp != dbp) {
			LEAVE_CRITICAL_SECTION(&csDBL);
			return ERROR_DB_LOCK;
		}
	}

	LEAVE_CRITICAL_SECTION(&csDBL);

	return 0;
}

/*=======================================================================
 |
 |		R[hbN`FbN
 |
 |	SHORT	_RecordLockCheck(dbp)
 |
 |		PDB	dbp;		ca|C^
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
static	SHORT	_RecordLockCheck(PDB dbp)
{
	PDBF	dp;
	PDBLOCK	dlp;

	dp = dbp->dp;

	/* t@CbN`FbN */
	if (dp->readLockCount != 0 ||
			(dp->writeLockCount != 0 && dbp->writeLockCount == 0))
		return ERROR_DB_LOCK;

	ENTER_CRITICAL_SECTION(&csDBL);

	/* ǂݍ݃R[hbN`FbN */
	for (dlp = dp->rdlp; dlp != NULL; dlp = dlp->chain) {
		if (dlp->rno == dbp->rno) {
			LEAVE_CRITICAL_SECTION(&csDBL);
			return ERROR_DB_LOCK;
		}
	}

	/* ݃R[hbN`FbN */
	for (dlp = dp->wdlp; dlp != NULL; dlp = dlp->chain) {
		if (dlp->rno == dbp->rno) {
			if (dlp->dbp != dbp) {
				LEAVE_CRITICAL_SECTION(&csDBL);
				return ERROR_DB_LOCK;
			}
			break;
		}
	}

	LEAVE_CRITICAL_SECTION(&csDBL);

	return 0;
}

/*=======================================================================
 |
 |		폜R[h̃XLbv
 |
 |	SHORT	_SkipDeleted(dbp, n)
 |
 |		PDB	dbp;		ca|C^
 |		int	n;		PFփXLbv@|PFOփXLbv
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
static	SHORT	_SkipDeleted(PDB dbp, int n)
{
	SHORT	flag;
	SHORT	err;

	for (;;) {
		if (dbp->bof || dbp->eof)
			break;

		if (dbp->select != NULL) {
			if (dbp->rno <= dbp->selectRec &&
					(dbp->select[dbp->rno / 8] &
					bitTable1[dbp->rno % 8]) == 0) {
				if ((err = _Skip(dbp, (LONG)n)) != 0)
					return err;
				continue;
			}
		}

		if (dbp->setDeleted != 0) {
			if ((err = DBFCheckDeleted(dbp->dp, dbp->rno, &flag))
								!= 0)
				return err;
			if (flag) {
				if ((err = _Skip(dbp, (LONG)n)) != 0)
					return err;
				continue;
			}
		}

		if (dbp->filter != NULL) {
			if ((err = DBFRead(dbp->dp, dbp->rno, dbp->rbp)) != 0)
				return err;

			if (CheckFilter(dbp) == 0) {
				if ((err = _Skip(dbp, (LONG)n)) != 0)
					return err;
				continue;
			}
		}
		break;
	}

	return 0;
}

/*=======================================================================
 |
 |		R[h̑Oړ
 |
 |	SHORT	_Skip(dbp, n)
 |
 |		PDB	dbp;		ca|C^
 |		LONG	n;		ړR[h
 |
 |		Ԓl			G[R[h
 |
 =======================================================================*/
static	SHORT	_Skip(PDB dbp, LONG n)
{
	PDBF	dp;
	PIDX	ip;
	LONG	rno;
	SHORT	err;

	dp = dbp->dp;
	ip = dbp->ip[dbp->master];

	rno = dbp->rno;
	if (ip == NULL) {
		/* CfbNXt@CȂꍇ */
		if (n > 0 && dbp->bof)
			rno = n;
		else if (n < 0 && dbp->eof)
			rno = dp->dhp->nRec + n + 1;
		else
			rno = dbp->rno + n;

		if (rno <= 0)
			_CheckBof(dbp, 0L);
		else if (rno > dp->dhp->nRec)
			_CheckEof(dbp, 0L);
		else
			_CheckEof(dbp, rno);
	} else {
		/* CfbNXt@Cꍇ */
		if (n > 0) {
			if (dbp->bof) {
				if ((err = IDXTop(ip, &rno)) != 0)
					return err;
				n--;
			}
			while (n-- != 0) {
				if ((err = IDXNext(ip, &rno)) != 0)
					return err;
				if (rno == 0)
					break;
			}
			_CheckEof(dbp, rno);
		} else if (n < 0) {
			if (dbp->eof) {
				if ((err = IDXBottom(ip, &rno)) != 0)
					return err;
				n++;
			}
			while (n++ != 0) {
				if ((err = IDXBack(ip, &rno)) != 0)
					return err;
				if (rno == 0)
					break;
			}
			_CheckBof(dbp, rno);
		}
	}

	return 0;
}

/*=======================================================================
 |
 |		ane`FbN
 |
 |	VOID	_CheckBof(dbp, rno)
 |
 |		PDB	dbp;		ca|C^
 |		LONG	rno;		R[hԍ
 |
 =======================================================================*/
static	VOID	_CheckBof(PDB dbp, LONG rno)
{
	if (dbp->dp->dhp->nRec == 0) {
		/* R[hPȂꍇ */
		dbp->rno = 1;
		dbp->bof = 1;
		dbp->eof = 1;
	} else {
		if (rno == 0) {
			dbp->rno = 1;
			dbp->bof = 1;
			dbp->eof = 0;
		} else {
			dbp->rno = rno;
			dbp->bof = 0;
			dbp->eof = 0;
		}
	}
}

/*=======================================================================
 |
 |		dne`FbN
 |
 |	VOID	_CheckEof(dbp, rno)
 |
 |		PDB	dbp;		ca|C^
 |		LONG	rno;		R[hԍ
 |
 =======================================================================*/
static	VOID	_CheckEof(PDB dbp, LONG rno)
{
	if (dbp->dp->dhp->nRec == 0) {
		/* R[hPȂꍇ */
		dbp->rno = 1;
		dbp->bof = 1;
		dbp->eof = 1;
	} else {
		if (rno == 0) {
			dbp->rno = dbp->dp->dhp->nRec + 1;
			dbp->bof = 0;
			dbp->eof = 1;
		} else {
			dbp->rno = rno;
			dbp->bof = 0;
			dbp->eof = 0;
		}
	}
}
